Attribute VB_Name = "mBrush"
Option Explicit

Private Type RECT2
    x1 As Long
    y1 As Long
    x2 As Long
    y2 As Long
End Type

Private Type RGBQUAD
    B As Byte
    G As Byte
    R As Byte
    A As Byte
End Type

Private Type SAFEARRAYBOUND
    cElements As Long
    lLbound   As Long
End Type

Private Type SAFEARRAY2D
    cDims      As Integer
    fFeatures  As Integer
    cbElements As Long
    cLocks     As Long
    pvData     As Long
    Bounds(1)  As SAFEARRAYBOUND
End Type

Private Declare Function SetRect Lib "user32" (lpRect As RECT2, _
        ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, _
        ByVal y2 As Long) As Long
Private Declare Function IntersectRect Lib "user32" ( _
        lpDestRect As RECT2, lpSrc1Rect As RECT2, _
        lpSrc2Rect As RECT2) As Long
Private Declare Function IsRectEmpty Lib "user32" ( _
        lpRect As RECT2) As Long
Private Declare Function OffsetRect Lib "user32" ( _
        lpRect As RECT2, ByVal x As Long, ByVal y As Long) As Long

Private Declare Function VarPtrArray Lib "msvbvm60" Alias "VarPtr" ( _
        Ptr() As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
        lpDst As Any, lpSrc As Any, ByVal ByteLength As Long)

Private m_bPainted() As Byte

Public Sub DoBrush(oDIB As cDIBPic, ByVal x As Long, ByVal y As Long, _
        ByVal d As Long, ByVal Pressure As Long, ByVal Color As Long)
  
  Dim uBits() As RGBQUAD
  Dim uSA     As SAFEARRAY2D
  
  Dim uBrushRect As RECT2
  Dim uDIBRect   As RECT2

  Dim i As Long, iOut As Long
  Dim j As Long, jOut As Long

  Dim bR As Long, bG As Long, bB As Long
  Dim rBr     As Long
  Dim rBrpow2 As Long
  Dim cP1     As Single
  Dim cP2     As Single

    If (oDIB.hDIB <> 0) Then
    
        rBr = d * 0.5
        rBrpow2 = rBr * rBr + 1
        y = Val(oDIB.Height - y) '[-] Deswegen das verflixte Minus!
        
        bR = (Color And &HFF&)
        bG = (Color And &HFF00&) \ 256
        bB = (Color And &HFF0000) \ 65536
    
        cP1 = Pressure / 100
        cP2 = 1 - cP1
        
        Call SetRect(uBrushRect, x - rBr, y - rBr, _
                           x + rBr + -(rBr = 0), y + rBr - (rBr = 0))
        Call SetRect(uDIBRect, 0, 0, oDIB.Width - 1, oDIB.Height - 1)
        Call IntersectRect(uBrushRect, uBrushRect, uDIBRect)
        Call OffsetRect(uBrushRect, -x, -y)
        
        If (IsRectEmpty(uBrushRect) = 0) Then
            
            Call pvBuildSA(uSA, oDIB)
            Call CopyMemory(ByVal VarPtrArray(uBits()), VarPtr(uSA), 4)
    
            For j = uBrushRect.y1 To uBrushRect.y2
                jOut = j + y
                For i = uBrushRect.x1 To uBrushRect.x2
                    If (i * i + j * j < rBrpow2) Then
                        iOut = i + x
                        If (m_bPainted(iOut, jOut) = 0) Then
                            m_bPainted(iOut, jOut) = 1
                            With uBits(iOut, jOut)
                                .R = cP1 * bR + cP2 * .R
                                .G = cP1 * bG + cP2 * .G
                                .B = cP1 * bB + cP2 * .B
                            End With
                        End If
                    End If
                Next i
            Next j
            Call CopyMemory(ByVal VarPtrArray(uBits), 0&, 4)
        End If
    End If
End Sub


Public Sub CreateLUT(ByVal W As Long, ByVal H As Long)
    On Error GoTo Err
    ReDim m_bPainted(W - 1, H - 1) As Byte
    Exit Sub
    
Err:
End Sub

Public Sub DestroyLUT()
   On Error GoTo Err
   Erase m_bPainted()
   Exit Sub
    
Err:
End Sub

Private Sub pvBuildSA(uSA As SAFEARRAY2D, oDIB As cDIBPic)
    With uSA
        .cbElements = IIf(App.LogMode = 1, 1, 4)
        .cDims = 2
        .Bounds(0).lLbound = 0
        .Bounds(0).cElements = oDIB.Height
        .Bounds(1).lLbound = 0
        .Bounds(1).cElements = oDIB.Width
        .pvData = oDIB.lpBits
    End With
End Sub
